OGRE: Ogre::NodeAnimationTrack Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::NodeAnimationTrack Class Reference
Core » Animation

Specialised AnimationTrack for dealing with node transforms. More...

`#include <OgreAnimationTrack.h>`

Inheritance diagram for Ogre::NodeAnimationTrack:
[legend]

## Public Member Functions
| NodeAnimationTrack (Animation *parent, unsigned short handle)
| Constructor.
| NodeAnimationTrack (Animation *parent, unsigned short handle, Node *targetNode)
| Constructor, associates with a Node.
virtual | ~NodeAnimationTrack ()
| Destructor.
void | _applyBaseKeyFrame (const KeyFrame *base) override
| Internal method to re-base the keyframes relative to a given keyframe.
NodeAnimationTrack * | _clone (Animation *newParent) const
| Clone this track (internal use only).
void | _keyFrameDataChanged (void) const override
| Internal method used to tell the track that keyframe data has been changed, which may cause it to rebuild some internal data.
void | apply (const TimeIndex &timeIndex, Real weight=1.0, Real scale=1.0f) override
| Applies an animation track to the designated target.
virtual void | applyToNode (Node *node, const TimeIndex &timeIndex, Real weight=1.0, Real scale=1.0f)
| As the 'apply' method but applies to a specified Node instead of associated node.
virtual TransformKeyFrame * | createNodeKeyFrame (Real timePos)
| Creates a new KeyFrame and adds it to this animation at the given time index.
virtual Node * | getAssociatedNode (void) const
| Returns a pointer to the associated Node object (if any).
void | getInterpolatedKeyFrame (const TimeIndex &timeIndex, KeyFrame *kf) const override
| Gets a KeyFrame object which contains the interpolated transforms at the time index specified.
virtual TransformKeyFrame * | getNodeKeyFrame (unsigned short index) const
| Returns the KeyFrame at the specified index.
virtual bool | getUseShortestRotationPath () const
| Gets the method of rotation calculation.
bool | hasNonZeroKeyFrames (void) const override
| Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out.
void | optimise (void) override
| Optimise the current track by removing any duplicate keyframes.
virtual void | setAssociatedNode (Node *node)
| Sets the associated Node object which will be automatically affected by calls to 'apply'.
virtual void | setUseShortestRotationPath (bool useShortestPath)
| Sets the method of rotation calculation.
Public Member Functions inherited from Ogre::AnimationTrack
| AnimationTrack (Animation *parent, unsigned short handle)
| Constructor.
virtual | ~AnimationTrack ()
virtual void | _buildKeyFrameIndexMap (const std::vector< Real > &keyFrameTimes)
| Internal method to build keyframe time index map to translate global lower bound index to local lower bound index.
virtual void | _collectKeyFrameTimes (std::vector< Real > &keyFrameTimes)
| Internal method to collect keyframe times, in unique, ordered format.
virtual KeyFrame * | createKeyFrame (Real timePos)
| Creates a new KeyFrame and adds it to this animation at the given time index.
unsigned short | getHandle (void) const
| Get the handle associated with this track.
KeyFrame * | getKeyFrame (size_t index) const
| Returns the KeyFrame at the specified index.
float | getKeyFramesAtTime (const TimeIndex &timeIndex, KeyFrame **keyFrame1, KeyFrame **keyFrame2, unsigned short *firstKeyIndex=0) const
| Gets the 2 KeyFrame objects which are active at the time given, and the blend value between them.
size_t | getNumKeyFrames (void) const
| Returns the number of keyframes in this animation.
Animation * | getParent () const
| Returns the parent Animation object for this track.
void | removeAllKeyFrames (void)
| Removes all the KeyFrames from this track.
virtual void | removeKeyFrame (unsigned short index)
| Removes a KeyFrame by it's index.
virtual void | setListener (Listener *l)
| Set a listener for this track.

## Detailed Description

Specialised AnimationTrack for dealing with node transforms.

## Constructor & Destructor Documentation

## ◆ NodeAnimationTrack() [1/2]

Ogre::NodeAnimationTrack::NodeAnimationTrack | ( | Animation * | parent,
|  | unsigned short | handle )

Constructor.

Referenced by _clone().

## ◆ NodeAnimationTrack() [2/2]

Ogre::NodeAnimationTrack::NodeAnimationTrack | ( | Animation * | parent,
|  | unsigned short | handle,
|  | Node * | targetNode )

Constructor, associates with a Node.

## ◆ ~NodeAnimationTrack()

virtual Ogre::NodeAnimationTrack::~NodeAnimationTrack | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ createNodeKeyFrame()

virtual TransformKeyFrame * Ogre::NodeAnimationTrack::createNodeKeyFrame | ( | Real | timePos | ) |
| virtual

Creates a new KeyFrame and adds it to this animation at the given time index.

It is better to create KeyFrames in time order.

Parameters

  timePos | The time from which this KeyFrame will apply.

## ◆ getAssociatedNode()

virtual Node * Ogre::NodeAnimationTrack::getAssociatedNode | ( | void |  | ) | const
| virtual

Returns a pointer to the associated Node object (if any).

## ◆ setAssociatedNode()

virtual void Ogre::NodeAnimationTrack::setAssociatedNode | ( | Node * | node | ) |
| virtual

Sets the associated Node object which will be automatically affected by calls to 'apply'.

## ◆ applyToNode()

virtual void Ogre::NodeAnimationTrack::applyToNode | ( | Node * | node,
|  | const TimeIndex & | timeIndex,
|  | Real | weight = 1.0,
|  | Real | scale = 1.0f )
| virtual

As the 'apply' method but applies to a specified Node instead of associated node.

## ◆ setUseShortestRotationPath()

virtual void Ogre::NodeAnimationTrack::setUseShortestRotationPath | ( | bool | useShortestPath | ) |
| virtual

Sets the method of rotation calculation.

## ◆ getUseShortestRotationPath()

virtual bool Ogre::NodeAnimationTrack::getUseShortestRotationPath | ( |  | ) | const
| virtual

Gets the method of rotation calculation.

## ◆ getInterpolatedKeyFrame()

void Ogre::NodeAnimationTrack::getInterpolatedKeyFrame | ( | const TimeIndex & | timeIndex,
|  | KeyFrame * | kf ) const
| overridevirtual

Gets a KeyFrame object which contains the interpolated transforms at the time index specified.

The KeyFrame objects held by this class are transformation snapshots at discrete points in time. Normally however, you want to interpolate between these keyframes to produce smooth movement, and this method allows you to do this easily. In animation terminology this is called 'tweening'.

Parameters

  timeIndex | The time (in relation to the whole animation sequence)
  kf | Keyframe object to store results

Implements Ogre::AnimationTrack.

## ◆ apply()

void Ogre::NodeAnimationTrack::apply | ( | const TimeIndex & | timeIndex,
|  | Real | weight = 1.0,
|  | Real | scale = 1.0f )
| overridevirtual

Applies an animation track to the designated target.

Parameters

  timeIndex | The time position in the animation to apply.
  weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.
  scale | The scale to apply to translations and scalings, useful for adapting an animation to a different size target.

Implements Ogre::AnimationTrack.

## ◆ _keyFrameDataChanged()

void Ogre::NodeAnimationTrack::_keyFrameDataChanged | ( | void |  | ) | const
| overridevirtual

Internal method used to tell the track that keyframe data has been changed, which may cause it to rebuild some internal data.

Reimplemented from Ogre::AnimationTrack.

## ◆ getNodeKeyFrame()

virtual TransformKeyFrame * Ogre::NodeAnimationTrack::getNodeKeyFrame | ( | unsigned short | index | ) | const
| virtual

Returns the KeyFrame at the specified index.

## ◆ hasNonZeroKeyFrames()

bool Ogre::NodeAnimationTrack::hasNonZeroKeyFrames | ( | void |  | ) | const
| overridevirtual

Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out.

Reimplemented from Ogre::AnimationTrack.

## ◆ optimise()

void Ogre::NodeAnimationTrack::optimise | ( | void |  | ) |
| overridevirtual

Optimise the current track by removing any duplicate keyframes.

Reimplemented from Ogre::AnimationTrack.

## ◆ _clone()

NodeAnimationTrack * Ogre::NodeAnimationTrack::_clone | ( | Animation * | newParent | ) | const

Clone this track (internal use only).

References NodeAnimationTrack().

## ◆ _applyBaseKeyFrame()

void Ogre::NodeAnimationTrack::_applyBaseKeyFrame | ( | const KeyFrame * | base | ) |
| overridevirtual

Internal method to re-base the keyframes relative to a given keyframe.

Reimplemented from Ogre::AnimationTrack.

The documentation for this class was generated from the following file:

- OgreAnimationTrack.h